#include <QtGui>
#include <taglib/tag.h>
#include <taglib/fileref.h>

#include "detailsdialog.h"
#include "decoder_flac.h"
#include "tag.h"
#include "decoderflacfactory.h"


// DecoderFLACFactory

bool DecoderFLACFactory::supports(const QString &source) const
{
    
    return (source.right(5).toLower() == ".flac");
}

const QString &DecoderFLACFactory::name() const
{
    static QString name (tr("FLAC Plugin"));
    return name;
}


const QString &DecoderFLACFactory::filter() const
{
    static QString filter("*.flac");
    return filter;
}


const QString &DecoderFLACFactory::description() const
{
    static QString desc(tr("FLAC Files"));
    return desc;
}


Decoder *DecoderFLACFactory::create(QObject *parent, QIODevice *input,
                                   Output *output,
                                   bool deletable)
{
    //if (deletable)
    return new DecoderFLAC(parent, this, input, output);

    /*static DecoderOgg *decoder = 0;
    if (! decoder) {
    decoder = new DecoderOgg(parent, this, input, output);
    } else {
    decoder->setInput(input);
    decoder->setOutput(output);
    }

    return decoder;*/
}

FileTag *DecoderFLACFactory::createTag(const QString &source)
{
    FileTag *tag = new Tag(source);
    return tag;
}

void DecoderFLACFactory::showDetails(QWidget *parent, const QString &path)
{
    DetailsDialog *d = new DetailsDialog(parent, path);
    d -> show();
}

void DecoderFLACFactory::showSettings(QWidget *parent)
{
    /*SettingsDialog *s = new SettingsDialog(parent);
    s -> show();*/
}

Q_EXPORT_PLUGIN(DecoderFLACFactory)
