/***************************************************************************
 *   Copyright (C) 2006 by Ilya Kotov                                       *
 *   forkotov02@hotmail.ru                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef EQWIDGET_H
#define EQWIDGET_H

#include <pixmapwidget.h>

/**
	@author Ilya Kotov <forkotov02@hotmail.ru>
*/
class Skin;
class EqTitleBar;
class EqSlider;
class ToggleButton;
class EQGraph;

class EqWidget : public PixmapWidget
{
Q_OBJECT
public:
    EqWidget(QWidget *parent = 0);

    ~EqWidget();

    //void setEQ(int preamp, int bands[10]);
    int preamp();
    int gain(int);
    bool isEQEnabled();

signals:
    void valueChanged();

private slots:
    void updateSkin();

    void setPreamp(int);
    void setGain();

private:
    void readSettings();
    void writeSettings();
    Skin *m_skin;
    EqTitleBar *m_titleBar;
    EqSlider* m_preamp;
    QList<EqSlider*> m_sliders;
    QPoint m_pos;
    ToggleButton *m_on;
    EQGraph *m_eqg;

protected:
    //void enterEvent(QEvent*);
    //void leaveEvent(QEvent*);
    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);

};

#endif
